ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.5 by root, Thu Mar 8 15:19:08 2007 UTC vs.
Revision 1.53 by root, Sun Aug 19 09:27:08 2007 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
14 15
15use Getopt::Long; 16use Getopt::Long;
16use Coro::Event; 17use Coro::Event;
17use AnyEvent; 18use AnyEvent;
18use IO::AIO (); 19use IO::AIO ();
19use File::Temp; 20use File::Temp;
20use Crossfire; 21use Crossfire;
21use Coro; 22use Coro;
22use Coro::AIO; 23use Coro::AIO;
24use Coro::Util;
23use POSIX (); 25use POSIX ();
26use Digest::MD5;
27use Carp;
28use Coro::Channel;
29use Coro::Storable; $Storable::canonical = 1;
30
31$SIG{QUIT} = sub { Carp::cluck "QUIT" };
24 32
25sub usage { 33sub usage {
26 warn <<EOF; 34 warn <<EOF;
27Usage: cfutil [-v] [-q] [--force] [--cache] 35Usage: cfutil [-v] [-q] [--force] [--cache]
28 [--install-arch path] 36 [--install-arch path]
40my $CACHE = 0; 48my $CACHE = 0;
41my $FORCE; 49my $FORCE;
42my $TMPDIR = "/tmp/cfutil$$~"; 50my $TMPDIR = "/tmp/cfutil$$~";
43my $TMPFILE = "aaaa0"; 51my $TMPFILE = "aaaa0";
44 52
53our %COLOR = (
54 black => 0,
55 white => 1,
56 navy => 2,
57 red => 3,
58 orange => 4,
59 blue => 5,
60 darkorange => 6,
61 green => 7,
62 lightgreen => 8,
63 grey => 9,
64 brown => 10,
65 gold => 11,
66 tan => 12,
67);
68
45END { system "rm", "-rf", $TMPDIR } 69END { system "rm", "-rf", $TMPDIR }
46 70
47Event->signal (signal => "INT", cb => sub { exit 1 }); 71Event->signal (signal => "INT", cb => sub { exit 1 });
48Event->signal (signal => "TERM", cb => sub { exit 1 }); 72Event->signal (signal => "TERM", cb => sub { exit 1 });
49 73
66} 90}
67 91
68sub inst_maps($) { 92sub inst_maps($) {
69 my (undef, $path) = @_; 93 my (undef, $path) = @_;
70 94
71 print "installing '$path' to '$DATADIR/maps'\n\n"; 95 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
72 96
73 if (!-f "$path/regions") { 97 if (!-f "$path/regions") {
74 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 98 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
75 exit 1 unless $FORCE; 99 exit 1 unless $FORCE;
76 } 100 }
77 101
78 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 102 system $RSYNC, "-a", "--chmod=u=rwX,go=rX", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"
103 and die "map installation failed.\n";
104
105 print "maps installed successfully.\n";
79} 106}
80 107
81{ 108{
82 our @PNG; 109 our %ANIMINFO;
110 our %FACEINFO;
111 our %RESOURCE;
83 our @ARC; 112 our @ARC;
113 our %ARC;
114 our $TRS;
84 our $NFILE; 115 our $NFILE;
85 our @FACE;
86 our $ANIM; 116 our $PATH;
87 117
88 our (@png, @trs, @arc); # files we are interested in 118 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
89 119
120 our $c_arc = new Coro::Channel;
121 our $c_trs = new Coro::Channel;
122 our $c_res = new Coro::Channel;
123
124 our @c_png;
125
90 sub commit_png { 126 sub commit_png($$$) {
91 my ($name, $data) = @_; 127 my ($name, $data, $T) = @_;
92 128
93 push @PNG, [$name => $data]; 129 $FACEINFO{$name}{"data$T"} = $data;
94 } 130 }
95 131
96 sub process_png { 132 sub process_png {
97 while (@png) { 133 while (@c_png) {
98 my $path = pop @png; 134 my ($path, $delete) = @{pop @c_png};
99 135
100 my $png; 136 my $png;
101 aio_lstat $path; 137 aio_lstat $path;
102 my ($size, $mtime) = (stat _)[7,9]; 138 my ($size, $mtime) = (stat _)[7,9];
103 139
104 if (0 > aio_load $path, $png) { 140 if (0 > aio_load $path, $png) {
105 warn "$path: $!, skipping.\n"; 141 warn "$path: $!, skipping.\n";
106 next; 142 next;
107 } 143 }
108 144
109 # quickly extratc width and height of the (necessarily PNG) image 145 my $stem = $path;
110 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 146 my $T;
111 warn "$path: not a recongized png file, skipping.\n";
112 next;
113 }
114 147
115 my ($w, $h) = unpack "NN", $1; 148 if ($stem =~ s/\.32x32\.png~?$//) {
116
117 (my $face = $path) =~ s/^.*\///;
118 my $T = 32; 149 $T = 32;
119 150 } elsif ($stem =~ s/\.64x64\.png~?$//) {
120 unless ($face =~ s/\.base\.(...)\.png$/.$1/) { 151 $T = 64;
152 } else {
121 warn "$path: weird filename, skipping.\n"; 153 warn "$path: weird filename, skipping.\n";
122 next; 154 next;
123 } 155 }
156
157 # quickly extract width and height of the (necessarily PNG) image
158 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
159 warn "$path: not a recognized png file, skipping.\n";
160 next;
161 }
162
163 my ($w, $h) = unpack "NN", $1;
124 164
125 if ($w < $T || $h < $T) { 165 if ($w < $T || $h < $T) {
126 warn "$path: too small ($w $h), skipping.\n"; 166 warn "$path: too small ($w $h), skipping.\n";
127 next; 167 next;
128 } 168 }
130 if ($w % $T || $h % $T) { 170 if ($w % $T || $h % $T) {
131 warn "$path: weird png size ($w $h), skipping.\n"; 171 warn "$path: weird png size ($w $h), skipping.\n";
132 next; 172 next;
133 } 173 }
134 174
175 unless ($path =~ /~$/) {
176 # possibly enlarge
177 if (0 > aio_stat "$stem.64x64.png") {
178 my $other = "$stem.64x64.png~";
179
180 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
181 fork_sub {
182 my $CROP;
183 my $SRC = "png:\Q$path\E";
184
185 # check if this is a wall. ultra-ugly. ultra-ultra-ugly.
186 if ($path =~ /^(.*\/wall\/.*_)([0-9A-F])(\.x11.*\.png)$/) {
187 my ($pfx, $dir, $sfx) = ($1, hex $2, $3);
188 #check for 0..F images to be sure(?) this is a wall
189 unless (grep { !-e sprintf "%s%X%s", $pfx, $_, $sfx } 0..15) {
190 # add a 4px border and add other images around it
191 $CROP = "-shave 8x8 +repage";
192
193 $w += 8;
194 $h += 8;
195
196 $SRC = "-size ${w}x${h} xc:transparent";
197 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
198
199 # 8 surrounding images
200 for (
201 # x y b r0 r1
202 [-1, -1, 0, 6],
203 [ 0, -1, 1, 10, 14],
204 [+1, -1, 0, 12],
205
206 [-1, 0, 8, 5, 7],
207 #
208 [+1, 0, 2, 5, 13],
209
210 [-1, +1, 0, 3],
211 [ 0, +1, 4, 10, 11],
212 [+1, +1, 0, 9],
213 ) {
214 my ($x, $y, $d, $r0, $r1) = @$_;
215 $SRC .= sprintf " png:%s%X%s -geometry %+d%+d -composite",
216 "\Q$pfx",
217 ($dir & $d) ? $r1 : $r0,
218 "\Q$sfx",
219 $x * ($w - 8) + 4,
220 $y * ($h - 8) + 4;
221 }
222 }
223 }
224
225 system "convert -depth 8 $SRC rgba:-"
226 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
227 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
228 and die "convert/cfhq2xa pipeline error: status $? ($!)";
229 system $OPTIPNG, "-i0", "-q", "$other~";
230 die "$other~ has zero size, aborting." unless -s "$other~";
231 rename "$other~", $other;
232 };
233 }
234
235 push @c_png, [$other, !$CACHE];
236 }
237
238 # possibly scale down
239 if (0 > aio_stat "$stem.32x32.png") {
240 my $other = "$stem.32x32.png~";
241
242 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
243 fork_sub {
244 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
245 system $OPTIPNG, "-i0", "-q", "$other~";
246
247 # reduce smoothfaces >10000 bytes
248 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
249 my $ncolor = 256;
250 while () {
251 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
252 system $OPTIPNG, "-i0", "-q", "$other~~";
253 last if 10000 > -s "$other~~";
254 $ncolor = int $ncolor * 0.9;
255 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
256 }
257
258 printf "reduced %s from %d to %d bytes using %d colours.\n",
259 $other, -s "$other~", -s "$other~~", $ncolor
260 if $VERBOSE >= 2;
261 rename "$other~~", "$other~";
262 }
263
264 die "$other~ has zero size, aborting." unless -s "$other~";
265 rename "$other~", $other;
266 };
267 }
268
269 #warn "scaled down $path to $other\n";#d#
270 push @c_png, [$other, !$CACHE];
271 }
272 }
273
274 (my $face = $stem) =~ s/^.*\///;
275
276 # split all bigfaces, but avoid smoothfaces (*_S)
135 if (($w > $T || $h > $T) && $face !~ /_S\./) { 277 if (($w > $T || $h > $T) && $face !~ /_S\./) {
136 # split 278 # split
137 my @tile; 279 my @tile;
138 for my $x (0 .. (int $w / $T) - 1) { 280 for my $x (0 .. (int $w / $T) - 1) {
139 for my $y (0 .. (int $h / $T) - 1) { 281 for my $y (0 .. (int $h / $T) - 1) {
147 my @todo = grep { $_->[3] <= $mtime } @tile; 289 my @todo = grep { $_->[3] <= $mtime } @tile;
148 if (@todo) { 290 if (@todo) {
149 fork_sub { 291 fork_sub {
150 open my $convert, "|-", $CONVERT, 292 open my $convert, "|-", $CONVERT,
151 "png:-", 293 "png:-",
152 -negate,#d#
153 (map { 294 (map {
154 ( 295 (
155 "(", 296 "(",
156 "+clone", 297 "+clone",
157 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 298 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
299 "+repage",
300 -quality => "00",
158 -write => "png:$_->[2]~", 301 -write => "png32:$_->[2]~",
159 "+delete", 302 "+delete",
160 ")", 303 ")",
161 ) 304 )
162 } @todo), 305 } @todo),
163 "null:"; 306 "null:";
167 close $convert; 310 close $convert;
168 311
169 # pass 2, optimise, and rename 312 # pass 2, optimise, and rename
170 for (@todo) { 313 for (@todo) {
171 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 314 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
315 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
172 rename "$_->[2]~", $_->[2]; 316 rename "$_->[2]~", $_->[2];
173 } 317 }
174 }; 318 };
175 } 319 }
176 320
180 324
181 if (0 > aio_load $file, $tile) { 325 if (0 > aio_load $file, $tile) {
182 die "$path: unable to read tile +$x+$y, aborting.\n"; 326 die "$path: unable to read tile +$x+$y, aborting.\n";
183 } 327 }
184 IO::AIO::aio_unlink $file unless $CACHE; 328 IO::AIO::aio_unlink $file unless $CACHE;
185 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 329 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
186 } 330 }
187 } else { 331 } else {
188 # use as-is (either small, use smooth) 332 # use as-is (either small, use smooth)
189 commit_png $face, $png; 333 commit_png $face, $png, $T;
190 } 334 }
335
336 aio_unlink $path if $delete;
191 } 337 }
192 } 338 }
193 339
194 sub process_arc { 340 sub process_arc {
195 while (@arc) { 341 while (my $job = $c_arc->get) {
196 my ($dir, $file) = @{pop @arc}; 342 my ($dir, $file) = @$job;
197 343
198 my $arc; 344 my $arc;
199 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 345 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
200 346
201 my $arc = read_arch "$dir/$file"; 347 my $arc = read_arch "$dir/$file";
202 for my $o (values %$arc) { 348 for my $o (values %$arc) {
203 push @ARC, $o; 349 push @ARC, $o;
350 for (my $m = $o; $m; $m = $m->{more}) {
351 $ARC{$m->{_name}} = $m;
352 }
353
354 $o->{editor_folder} = $dir;
355
356 my $visibility = delete $o->{visibility};
357 my $magicmap = delete $o->{magicmap};
358
359 # find upper left corner :/
360 # omg, this is sooo broken
204 my ($dx, $dy); 361 my ($dx, $dy);
205 # omg, this is sooo broken
206 for (my $o = $o; $o; $o = $o->{more}) { 362 for (my $o = $o; $o; $o = $o->{more}) {
207 $dx = $o->{x} if $o->{x} < $dx; 363 $dx = $o->{x} if $o->{x} < $dx;
208 $dy = $o->{y} if $o->{y} < $dy; 364 $dy = $o->{y} if $o->{y} < $dy;
209 } 365 }
366
210 for (my $o = $o; $o; $o = $o->{more}) { 367 for (my $o = $o; $o; $o = $o->{more}) {
211 my $x = $o->{x} - $dx; 368 my $x = $o->{x} - $dx;
212 my $y = $o->{y} - $dy; 369 my $y = $o->{y} - $dy;
370
371 my $ext = $x|$y ? "+$x+$y" : "";
372
373 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
374
375 $visibility = delete $o->{visibility} if exists $o->{visibility};
376 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
377
378 my $anim = delete $o->{anim};
379
213 if ($x|$y) { 380 if ($anim) {
214 $_ .= "+$x+$y" for $o->{face}, @{$o->{anim} || []}; 381 # possibly add $ext to the animation name to avoid
382 # the need to specify archnames for all parts
383 # of a multipart archetype.
384 $o->{animation} = "$o->{_name}";
385 my $facings = 1;
386 my @frames;
387
388 for (@$anim) {
389 if (/^facings\s+(\d+)/) {
390 $facings = $1*1;
391 } elsif (/^blank.x11$|^empty.x11$/) {
392 push @frames, $_;
393 } else {
394 push @frames, "$_$ext";
395 }
396 }
397
398 $ANIMINFO{$o->{animation}} = {
399 facings => $facings,
400 frames => \@frames,
401 };
215 } 402 }
403
404 for my $face ($o->{face} || (), @{$anim || []}) {
405 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/;
406
407 my $info = $FACEINFO{$face} ||= {};
408
409 $info->{arc} = $o;
410 $info->{visibility} = $visibility if defined $visibility;
411 $info->{magicmap} = $magicmap if defined $magicmap;
216 } 412 }
413
217 if (my $anim = delete $o->{anim}) { 414 if (my $smooth = delete $o->{smoothface}) {
218 $o->{animation} = $o->{_name}; 415 my %kv =split /\s+/, $smooth;
219 $ANIM .= join "", map "$_\n", 416 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
220 "anim $o->{_name}", 417 while (my ($face, $smooth) = each %kv) {
221 @$anim, 418 $FACEINFO{$face}{smooth} = $smooth;
222 "mina"; 419 $FACEINFO{$face}{smoothlevel} = $level;
420 }
421 }
223 } 422 }
224 } 423 }
225 } 424 }
226 } 425 }
227 426
228 sub process_trs { 427 sub process_trs {
229 while (@trs) { 428 while (my $job = $c_trs->get) {
230 my ($dir, $file) = @{pop @trs}; 429 my ($dir, $file) = @$job;
430 my $path = "$dir/$file";
431
432 my $trs;
433 if (0 > aio_load $path, $trs) {
434 warn "$path: $!, skipping.\n";
435 next;
436 }
437
438 $TRS .= $trs;
439 }
440 }
441
442 my %FILECACHE;
443
444 sub load_cached($;$) {
445 unless (exists $FILECACHE{$_[0]}) {
446 my $data;
447 if (0 < aio_load $_[0], $data) {
448 if ($_[1]) {
449 $data = eval { $_[1]->($data) };
450 warn "$_[0]: $@" if $@;
451 }
452 }
453
454 $FILECACHE{$_[0]} = $data;
455 }
456
457 $FILECACHE{$_[0]}
458 }
459
460 sub process_res {
461 while (my $job = $c_res->get) {
462 my ($dir, $file, $type) = @$job;
463
464 my $data;
465 aio_load "$dir/$file", $data;
466
467 my $meta = load_cached "$dir/meta", sub { JSON::XS::from_json shift };
468
469 next if $meta && !exists $meta->{$file};
470
471 $meta = {
472 %{ $meta->{"" } || {} },
473 %{ $meta->{$file} || {} },
474 };
475
476 if ($meta->{license} =~ s/^#//) {
477 $meta->{license} = ({
478 "pd" => "Public Domain",
479 "gpl" => "GNU General Public License, version 3.0 or any later",
480 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
481 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
482 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
483 })->{$meta->{license}}
484 || warn "$dir/$file: license tag '$meta->{license}' not found.";
485 }
486
487 $file =~ s/\.res$//;
488 $file =~ s/\.(ogg|wav|jpg|png)$//;
489
490 substr $dir, 0, 1 + length $PATH, "";
491
492 $RESOURCE{"$dir/$file"} = {
493 type => (delete $meta->{type}) || $type,
494 data => $data,
495 chksum => (Digest::MD5::md5 $data),
496 %$meta ? (meta => $meta) : (),
497 };
231 } 498 }
232 } 499 }
233 500
234 sub find_files; 501 sub find_files;
235 sub find_files { 502 sub find_files {
240 my ($dirs, $nondirs) = @_; 507 my ($dirs, $nondirs) = @_;
241 508
242 find_files "$path/$_" 509 find_files "$path/$_"
243 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 510 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
244 511
512 my $dir = $path;
513 substr $dir, 0, 1 + length $PATH, "";
514
245 for my $file (@$nondirs) { 515 for my $file (@$nondirs) {
516 if ($dir =~ /^music(?:\/|$)/) {
517 $c_res->put ([$path, $file, 3]) # FT_MUSIC
518 if $file =~ /\.(ogg)$/;
519
520 } elsif ($dir =~ /^sound(?:\/|$)/) {
521 $c_res->put ([$path, $file, 5]) # FT_SOUND
522 if $file =~ /\.(wav|ogg)$/;
523
524 } elsif ($dir =~ /^res(?:\/|$)/) {
525 $c_res->put ([$path, $file, 0]) # FT_FACE
526 if $file =~ /\.(jpg|png)$/;
527 $c_res->put ([$path, $file, 7]) # FT_RSRC
528 if $file =~ /\.(res)$/;
529
246 if ($file =~ /\.png$/) { 530 } elsif ($file =~ /\.png$/) {
247 push @png, "$path/$file"; 531 push @c_png, ["$path/$file", 0];
532
248 } elsif ($file =~ /\.trs$/) { 533 } elsif ($file =~ /\.trs$/) {
249 push @trs, [$path, $file]; 534 $c_trs->put ([$path, $file]);
535
250 } elsif ($file =~ /\.arc$/) { 536 } elsif ($file =~ /\.arc$/) {
251 push @arc, [$path, $file]; 537 $c_arc->put ([$path, $file]);
538
252 } else { 539 } else {
253 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 540 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
254 } 541 }
255 } 542 }
256 }; 543 };
257 } 544 }
258 545
259 sub inst_arch($) { 546 sub inst_arch($) {
260 my (undef, $path) = @_; 547 my (undef, $path) = @_;
261 548
549 $PATH = $path;
550
551 print "\n",
262 print "installing '$path' to '$DATADIR'\n\n"; 552 "Installing '$path' to '$DATADIR'\n",
553 "\n",
554 "This can take a long time if you run this\n",
555 "for the first time or do not use --cache.\n",
556 "\n",
557 "Unless you run verbosely, all following warning\n",
558 "or error messages indicate serious problems.\n",
559 "\n";
263 560
264 if (!-d "$path/treasures") { 561 if (!-d "$path/treasures") {
265 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 562 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
266 exit 1 unless $FORCE; 563 exit 1 unless $FORCE;
267 } 564 }
268 565
566 print "scanning files...\n" if $VERBOSE;
567
269 find_files $path; 568 find_files $path;
569
570 my @a_arc = map +(async \&process_arc), 1..2;
571 my @a_res = map +(async \&process_res), 1..2;
572 my @a_trs = map +(async \&process_trs), 1..2;
573
270 IO::AIO::flush; 574 IO::AIO::flush;
271 575
272 $_->join for ( 576 $c_res->put (undef) for @a_res;
273 (async \&process_png), (async \&process_png), 577 $c_arc->put (undef) for @a_arc;
274 (async \&process_trs), (async \&process_trs), 578 $c_trs->put (undef) for @a_trs;
275 (async \&process_arc), (async \&process_arc),
276 );
277 579
580 print "start file scan, arc, res processing...\n" if $VERBOSE;
581
582 $_->join for @a_arc; # need to parse all archetypes before png processing
583
584 print "end arc, start png processing...\n" if $VERBOSE;
585
586 # four png crunchers work fine for my 2x smp machine
587 my @a_png = map +(async \&process_png), 1..4;
588
589 $_->join for (@a_trs, @a_res, @a_png);
590
591 print "scanning done, processing results...\n" if $VERBOSE;
278 { 592 {
279 open my $fh, ">:utf8", "$DATADIR/animations~" 593 # remove path prefix from editor_folder
280 or die "$DATADIR/animations~: $!"; 594 substr $_->{editor_folder}, 0, 1 + length $path, ""
281 print $fh $ANIM; 595 for values %ARC;
596
597 print "resolving inheritance tree...\n" if $VERBOSE;
598 # resolve inherit
599 while () {
600 my $progress;
601 my $loop;
602
603 for my $o (values %ARC) {
604 if (my $other = $o->{inherit}) {
605 if (my $s = $ARC{$other}) {
606 if ($s->{inherit}) {
607 $loop = $s;
608 } else {
609 delete $o->{inherit};
610 my %s = %$s;
611 delete @s{qw(_name more name name_pl)};
612 %$o = ( %s, %$o );
613 ++$progress;
614 }
615 } else {
616 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
617 delete $ARC{$o->{_name}};
618 }
619 }
620 }
621
622 unless ($progress) {
623 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
624 if $loop;
625
626 last;
627 }
282 } 628 }
283 629
284 { 630 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
631 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
632
633 print "writing archetypes...\n" if $VERBOSE;
285 open my $fh, ">:utf8", "$DATADIR/archetypes~" 634 open my $fh, ">:utf8", "$DATADIR/archetypes~"
286 or die "$DATADIR/archetypes~: $!"; 635 or die "$DATADIR/archetypes~: $!";
287 print $fh Crossfire::archlist_to_string \@ARC; 636 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
288 } 637 }
289
290 @PNG = sort { $a->[0] cmp $b->[0] } @PNG;
291 638
292 { 639 {
640 print "writing treasures...\n" if $VERBOSE;
641 open my $fh, ">:utf8", "$DATADIR/treasures~"
642 or die "$DATADIR/treasures~: $!";
643 print $fh $TRS;
644 }
645
646 {
647 print "processing facedata...\n" if $VERBOSE;
648 while (my ($k, $v) = each %FACEINFO) {
649 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
650 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
651
652 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
653 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
654
655 $v->{chksum32} = Digest::MD5::md5 $v->{data32};
656 $v->{chksum64} = Digest::MD5::md5 $v->{data64};
657
658 if (my $magicmap = $v->{magicmap}) {
659 $magicmap =~ y/A-Z_\-/a-z/d;
660 $v->{magicmap} = $COLOR{$magicmap};
661 }
662
663 delete $v->{arc};
664 }
665
666 print "writing facedata...\n" if $VERBOSE;
293 open my $fh, ">:perlio", "$DATADIR/crossfire.0~" 667 open my $fh, ">:perlio", "$DATADIR/facedata~"
294 or die "$DATADIR/crossfire.0~: $!"; 668 or die "$DATADIR/facedata~: $!";
295 printf $fh "IMAGE %d %d %s\x0a%s", $_, (length $PNG[$_][1]), $PNG[$_][0], $PNG[$_][1] 669
296 for 0.. $#PNG; 670 print $fh freeze {
671 version => 2,
672 faceinfo => \%FACEINFO,
673 animinfo => \%ANIMINFO,
674 resource => \%RESOURCE,
297 } 675 };
676 }
298 677
299 rename "$DATADIR/archetypes~" , "$DATADIR/archetypes"; 678 print "committing files...\n" if $VERBOSE;
300 rename "$DATADIR/crossfire.0~", "$DATADIR/crossfire.0";
301 rename "$DATADIR/animations~" , "$DATADIR/animations";
302 679
303 die "--install-arch not fully implemented\n"; 680 for (qw(archetypes facedata treasures)) {
681 chmod 0644, "$DATADIR/$_~";
682 rename "$DATADIR/$_~", "$DATADIR/$_"
683 or die "$DATADIR/$_: $!";
684 }
685
686 print "archetype data installed successfully.\n";
304 } 687 }
305} 688}
306 689
307Getopt::Long::Configure ("bundling", "no_ignore_case"); 690Getopt::Long::Configure ("bundling", "no_ignore_case");
308GetOptions ( 691GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines